
// Code is based on the treemap class from Visualizing Data, First Edition, Copyright 2008 Ben Fry.

                            
class DataItem extends SimpleMapItem {
  int deweyClass;
  int margin = 3;

  DataItem(int deweyClass) {
    this.deweyClass = deweyClass;
  }
  
  void draw() {
    
    strokeWeight(1);
  // noStroke();
  // smooth();
    fill(palette[2][(int)random(0,palette[2].length)]);
    
    rect(x, y, w, h);
   
    for (int i = minFontSize; i <= maxFontSize; i++) {
      textFont(font,i);
     String s = ""+deweyClass;
      if (w < textWidth(s) + margin || h < (textAscent()+textDescent()) + margin) {
        textFont(font,i);
        break;
      }
    }

    // text
    fill(0);
    textAlign(CENTER, CENTER);
    text(deweyClass, x + w/2, y + h/2);
  }
}


