
// Code is based on the treemap class from Visualizing Data, First Edition, Copyright 2008 Ben Fry.

class DeweyMap extends SimpleMapModel {    
  HashMap dewey;
 
  DeweyMap() {
    dewey = new HashMap();
  }

  void addDewey(int d) {
    DataItem item = (DataItem) dewey.get(d);
    if (item == null) {
      item = new DataItem(d);
      dewey.put(d, item);
    }
    item.incrementSize();
    frequency[d]++;
  }

  void finishAdd() {
    items = new DataItem[dewey.size()];
    dewey.values().toArray(items);
  }
}



